Merge branch '17438-compute-images-script-fixes'
[arvados.git] / tools / compute-images / build.sh
1 #!/bin/bash
2
3 # Copyright (C) The Arvados Authors. All rights reserved.
4 #
5 # SPDX-License-Identifier: Apache-2.0
6
7 JSON_FILE=$1
8 ARVADOS_CLUSTER=$2
9 PROJECT_ID=$3
10 ACCOUNT_FILE=$4
11
12 read -rd "\000" helpmessage <<EOF
13 $(basename $0): Build cloud images for arvados-dispatch-cloud
14
15 Syntax:
16         $(basename $0) [options]
17
18 Options:
19
20   --json-file (required)
21       Path to the packer json file
22   --arvados-cluster-id (required)
23       The ID of the Arvados cluster, e.g. zzzzz
24   --aws-profile (default: false)
25       AWS profile to use (valid profile from ~/.aws/config
26   --aws-secrets-file (default: false, required if building for AWS)
27       AWS secrets file which will be sourced from this script
28   --aws-source-ami (default: false, required if building for AWS)
29       The AMI to use as base for building the images
30   --aws-region (default: us-east-1)
31       The AWS region to use for building the images
32   --aws-vpc-id (optional)
33       VPC id for AWS, otherwise packer will pick the default one
34   --aws-subnet-id
35       Subnet id for AWS otherwise packer will pick the default one for the VPC
36   --gcp-project-id (default: false, required if building for GCP)
37       GCP project id
38   --gcp-account-file (default: false, required if building for GCP)
39       GCP account file
40   --gcp-zone (default: us-central1-f)
41       GCP zone
42   --azure-secrets-file (default: false, required if building for Azure)
43       Azure secrets file which will be sourced from this script
44   --azure-resource-group (default: false, required if building for Azure)
45       Azure resource group
46   --azure-location (default: false, required if building for Azure)
47       Azure location, e.g. centralus, eastus, westeurope
48   --azure-sku (default: unset, required if building for Azure, e.g. 16.04-LTS)
49       Azure SKU image to use
50   --ssh_user  (default: packer)
51       The user packer will use to log into the image
52   --resolver (default: host's network provided)
53       The dns resolver for the machine
54   --reposuffix (default: unset)
55       Set this to "-dev" to track the unstable/dev Arvados repositories
56   --public-key-file (required)
57       Path to the public key file that a-d-c will use to log into the compute node
58   --debug
59       Output debug information (default: false)
60
61 EOF
62
63 JSON_FILE=
64 ARVADOS_CLUSTER_ID=
65 AWS_PROFILE=
66 AWS_SECRETS_FILE=
67 AWS_SOURCE_AMI=
68 AWS_VPC_ID=
69 AWS_SUBNET_ID=
70 GCP_PROJECT_ID=
71 GCP_ACCOUNT_FILE=
72 GCP_ZONE=
73 AZURE_SECRETS_FILE=
74 AZURE_RESOURCE_GROUP=
75 AZURE_LOCATION=
76 AZURE_CLOUD_ENVIRONMENT=
77 DEBUG=
78 SSH_USER=
79 AWS_DEFAULT_REGION=us-east-1
80 PUBLIC_KEY_FILE=
81
82 PARSEDOPTS=$(getopt --name "$0" --longoptions \
83     help,json-file:,arvados-cluster-id:,aws-source-ami:,aws-profile:,aws-secrets-file:,aws-region:,aws-vpc-id:,aws-subnet-id:,gcp-project-id:,gcp-account-file:,gcp-zone:,azure-secrets-file:,azure-resource-group:,azure-location:,azure-sku:,azure-cloud-environment:,ssh_user:,resolver:,reposuffix:,public-key-file:,debug \
84     -- "" "$@")
85 if [ $? -ne 0 ]; then
86     exit 1
87 fi
88
89 eval set -- "$PARSEDOPTS"
90 while [ $# -gt 0 ]; do
91     case "$1" in
92         --help)
93             echo >&2 "$helpmessage"
94             echo >&2
95             exit 1
96             ;;
97         --json-file)
98             JSON_FILE="$2"; shift
99             ;;
100         --arvados-cluster-id)
101             ARVADOS_CLUSTER_ID="$2"; shift
102             ;;
103         --aws-source-ami)
104             AWS_SOURCE_AMI="$2"; shift
105             ;;
106         --aws-profile)
107             AWS_PROFILE="$2"; shift
108             ;;
109         --aws-secrets-file)
110             AWS_SECRETS_FILE="$2"; shift
111             ;;
112         --aws-region)
113             AWS_DEFAULT_REGION="$2"; shift
114             ;;
115         --aws-vpc-id)
116             AWS_VPC_ID="$2"; shift
117             ;;
118         --aws-subnet-id)
119             AWS_SUBNET_ID="$2"; shift
120             ;;
121         --gcp-project-id)
122             GCP_PROJECT_ID="$2"; shift
123             ;;
124         --gcp-account-file)
125             GCP_ACCOUNT_FILE="$2"; shift
126             ;;
127         --gcp-zone)
128             GCP_ZONE="$2"; shift
129             ;;
130         --azure-secrets-file)
131             AZURE_SECRETS_FILE="$2"; shift
132             ;;
133         --azure-resource-group)
134             AZURE_RESOURCE_GROUP="$2"; shift
135             ;;
136         --azure-location)
137             AZURE_LOCATION="$2"; shift
138             ;;
139         --azure-sku)
140             AZURE_SKU="$2"; shift
141             ;;
142         --azure-cloud-environment)
143             AZURE_CLOUD_ENVIRONMENT="$2"; shift
144             ;;
145         --ssh_user)
146             SSH_USER="$2"; shift
147             ;;
148         --resolver)
149             RESOLVER="$2"; shift
150             ;;
151         --reposuffix)
152             REPOSUFFIX="$2"; shift
153             ;;
154         --public-key-file)
155             PUBLIC_KEY_FILE="$2"; shift
156             ;;
157         --debug)
158             # If you want to debug a build issue, add the -debug flag to the build
159             # command in question.
160             # This will allow you to ssh in, if you use the .pem file that packer
161             # generates in this directory as the ssh key. The base image uses the admin
162             # user and ssh port 22.
163             EXTRA=" -debug"
164             ;;
165         --)
166             if [ $# -gt 1 ]; then
167                 echo >&2 "$0: unrecognized argument '$2'. Try: $0 --help"
168                 exit 1
169             fi
170             ;;
171     esac
172     shift
173 done
174
175
176 if [[ "$JSON_FILE" == "" ]] || [[ ! -f "$JSON_FILE" ]]; then
177   echo >&2 "$helpmessage"
178   echo >&2
179   echo >&2 "ERROR: packer json file not found"
180   echo >&2
181   exit 1
182 fi
183
184 if [[ -z "$ARVADOS_CLUSTER_ID" ]]; then
185   echo >&2 "$helpmessage"
186   echo >&2
187   echo >&2 "ERROR: arvados cluster id not specified"
188   echo >&2
189   exit 1
190 fi
191
192 if [[ "$PUBLIC_KEY_FILE" == "" ]] || [[ ! -f "$PUBLIC_KEY_FILE" ]]; then
193   echo >&2 "$helpmessage"
194   echo >&2
195   echo >&2 "ERROR: public key file file not found"
196   echo >&2
197   exit 1
198 fi
199
200 if [[ ! -z "$AWS_SECRETS_FILE" ]]; then
201   source $AWS_SECRETS_FILE
202 fi
203
204 if [[ ! -z "$AZURE_SECRETS_FILE" ]]; then
205   source $AZURE_SECRETS_FILE
206 fi
207
208
209 EXTRA2=""
210
211 if [[ "$AWS_SOURCE_AMI" != "" ]]; then
212   EXTRA2+=" -var aws_source_ami=$AWS_SOURCE_AMI"
213 fi
214 if [[ "$AWS_PROFILE" != "" ]]; then
215   EXTRA2+=" -var aws_profile=$AWS_PROFILE"
216 fi
217 if [[ "$AWS_VPC_ID" != "" ]]; then
218   EXTRA2+=" -var vpc_id=$AWS_VPC_ID -var associate_public_ip_address=true "
219 fi
220 if [[ "$AWS_SUBNET_ID" != "" ]]; then
221   EXTRA2+=" -var subnet_id=$AWS_SUBNET_ID -var associate_public_ip_address=true "
222 fi
223 if [[ "$AWS_DEFAULT_REGION" != "" ]]; then
224   EXTRA2+=" -var aws_default_region=$AWS_DEFAULT_REGION"
225 fi
226 if [[ "$GCP_PROJECT_ID" != "" ]]; then
227   EXTRA2+=" -var project_id=$GCP_PROJECT_ID"
228 fi
229 if [[ "$GCP_ACCOUNT_FILE" != "" ]]; then
230   EXTRA2+=" -var account_file=$GCP_ACCOUNT_FILE"
231 fi
232 if [[ "$GCP_ZONE" != "" ]]; then
233   EXTRA2+=" -var zone=$GCP_ZONE"
234 fi
235 if [[ "$AZURE_RESOURCE_GROUP" != "" ]]; then
236   EXTRA2+=" -var resource_group=$AZURE_RESOURCE_GROUP"
237 fi
238 if [[ "$AZURE_LOCATION" != "" ]]; then
239   EXTRA2+=" -var location=$AZURE_LOCATION"
240 fi
241 if [[ "$AZURE_SKU" != "" ]]; then
242   EXTRA2+=" -var image_sku=$AZURE_SKU"
243 fi
244 if [[ "$AZURE_CLOUD_ENVIRONMENT" != "" ]]; then
245   EXTRA2+=" -var cloud_environment_name=$AZURE_CLOUD_ENVIRONMENT"
246 fi
247 if [[ "$SSH_USER" != "" ]]; then
248   EXTRA2+=" -var ssh_user=$SSH_USER"
249 fi
250 if [[ "$RESOLVER" != "" ]]; then
251   EXTRA2+=" -var resolver=$RESOLVER"
252 fi
253 if [[ "$REPOSUFFIX" != "" ]]; then
254   EXTRA2+=" -var reposuffix=$REPOSUFFIX"
255 fi
256 if [[ "$PUBLIC_KEY_FILE" != "" ]]; then
257   EXTRA2+=" -var public_key_file=$PUBLIC_KEY_FILE"
258 fi
259
260 echo packer build$EXTRA -var "arvados_cluster=$ARVADOS_CLUSTER_ID"$EXTRA2 $JSON_FILE
261 packer build$EXTRA -var "arvados_cluster=$ARVADOS_CLUSTER_ID"$EXTRA2 $JSON_FILE